/* Copyright (c) 2000-2001 ActiveState Corporation.
   See the file LICENSE.txt for licensing information. */

// start the extension
var g_peURL = new peURL()
registeredExtensions[registeredExtensions.length] = g_peURL;

function peURL() {
    this.name = 'peURL';
    this.log = getLoggingMgr().getLogger('peURL');
}

// The following two lines ensure proper inheritance (see Flanagan, p. 144).
peURL.prototype.constructor = peURL;

peURL.prototype.init = function() {
}

peURL.prototype.registerCommands = function() {
    extensionManager.registerCommand('cmd_openSpecifiedURL', this);
    extensionManager.registerCommand('cmd_openSpecifiedURLinTab', this);
}

peURL.prototype.registerEventHandlers = function() {
    extensionManager.addEventHandler(Components.interfaces.koIPart_URL,'ondblclick',this);
    extensionManager.addEventHandler(Components.interfaces.koIPart_URL, 'onUpdatePart',this);
}

peURL.prototype.registerMenus = function() {
    extensionManager.createMenuItem(Components.interfaces.koIPart_URL,
                                    'Open URL in browser',
                                    'cmd_openSpecifiedURL',
                                    null,
                                    null,
                                    true);
    extensionManager.createMenuItem(Components.interfaces.koIPart_URL,
                                    'Open URL in tab',
                                    'cmd_openSpecifiedURLinTab');
}

peURL.prototype.ondblclick = function(part,event) {
    if (part.type != 'URL' && part.type != 'webservice') return;
    this.openURL(part)
}

peURL.prototype.supportsCommand = function(command, part) {
    var items = gFocusedProjectView.getSelectedItems();
    if (items.length > 1) return false;

    var view = gFocusedProjectView;
    if (!view) return false;
    //dump("supportsCommand for " + command +'\n');
    switch (command) {
    case 'cmd_openSpecifiedURLinTab':
    case 'cmd_openSpecifiedURL':
        return true;
    default:
        break;
    }
    return false;
}

peURL.prototype.isCommandEnabled = peURL.prototype.supportsCommand;

peURL.prototype.doCommand = function(command) {
    var view, part;
    switch (command) {
    case 'cmd_openSpecifiedURLinTab':
        view = gFocusedProjectView;
        item = view.getSelectedItem();
        var docSvc = Components.classes['@activestate.com/koDocumentService;1']
                    .getService(Components.interfaces.koIDocumentService);
        var doc = docSvc.createDocumentFromURI(item.part.value);
        gViewMgr.topView.createViewFromDocument(doc,'browser');
        break;
    case 'cmd_openSpecifiedURL':
        view = gFocusedProjectView;
        part = view.getSelectedItem();
        this.openURL(part);
        break;
    default:
        break;
    }
}

peURL.prototype.openURL= function(item) {
    var part = item.part;
    //dump("part = " + part + " type = " + typeof(part) +'\n');
    var URL = part.value;
    //dump("URL = " + URL + ' type = ' + typeof(URL) +'\n');
    try {
        browse_OpenUrlInDefaultBrowser(URL);
    } catch (e) {
        this.log.error(e);
    }
}

function peURL_editProperties(item)
{
    var obj = new Object();
    obj.item = item;
    obj.task = 'edit';
    obj.imgsrc = 'chrome://jaguar/skin/images/xlink.gif';
    obj.type = 'url';
    obj.prettytype = 'URL';
    openWindowMultipleInstance(
        "chrome://jaguar/content/project/simplePartProperties.xul",
        "komodo_URLproperties",
        "chrome,centerscreen,close=yes,dialog=no,dependent=yes,resizable=yes", obj);
}

peURL.prototype.onUpdatePart = function(part,event)
{
    if (part.type == 'webservice') {
        part.renameable = true;
        part.iconstyle['WebService'] = 1;
    } else
    if (part.type == 'URL') {
        part.renameable = true;
        part.iconstyle['URL'] = 1;
    }
}

function AddURLAtIndex(URLtext,index) {
    try {
        var URL = Components.classes['@activestate.com/koPart?type=URL;1'].createInstance(Components.interfaces.koIPart_URL);
        URL.type = 'URL';
        var name = URLtext;
        var value = URLtext;
        if (URLtext.search("\n")) {
            var s = URLtext.split("\n");
            name = typeof(s[1])!='undefined'?s[1]:s[0];
            value = s[0];
        }
        URL.setStringAttribute('name', name);
        URL.value = value;
        gFocusedProjectView.manager.addItem(URL,index);
        //dump("leaving AddURL\n");
    } catch (e) {
        g_peURL.log.error(e);
    }
}

function AddURL(URLtext) {
    AddURLAtIndex(URLtext,-1);
}

function peURL_addURL(item)
{
    var part = Components.classes['@activestate.com/koPart?type=URL;1']
               .createInstance(Components.interfaces.koIPart_URL);
    part.setStringAttribute('name', 'New URL');
    part.value = '';
    var obj = new Object();
    obj.item = new partWrapper(part, 0);
    obj.task = 'new';
    obj.imgsrc = 'chrome://jaguar/skin/images/xlink.gif';
    obj.type = 'url';
    obj.prettytype = 'URL';
    obj.parent = item;
    openWindowMultipleInstance(
        "chrome://jaguar/content/project/simplePartProperties.xul",
        "komodo_urlproperties",
        "chrome,centerscreen,close=yes,dialog=no,modal=yes,resizable=yes", obj);
}
