#!/usr/bin/env python
# Copyright (c) 2004 ActiveState Corp, a division of Sophos Plc.
# See the file LICENSE.txt for licensing information.

"""Service to help other Komodo services finalize at Komodo shutdown."""

from xpcom import components, COMException, ServerException, nsError


class KoFinalizeService:
    _com_interfaces_ = [components.interfaces.koIFinalizeService]
    _reg_clsid_ = "{ED97B6BF-70C1-45D6-93FC-64E8B4DE435A}"
    _reg_contractid_ = "@activestate.com/koFinalizeService;1"
    _reg_desc_ = "Finalize registered components on Komodo shutdown"

    def __init__(self):
        self.finalizers = []
    def registerFinalizer(self, finalizer):
        self.finalizers.append(finalizer)
    def finalize(self):
        for finalizer in self.finalizers:
            #print "KoFinalizeService: finalizing %r" % finalizer
            finalizer.finalize()